/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import org.eclipse.core.runtime.IProgressMonitor;

public class KonfigAssDateiOperationen
{
  // public static void main(String[] args)
  // {
  // Display display = new Display();
  // Shell shell = new Shell(display);
  // shell.setLayout(new FillLayout());
  // Table table = new Table(shell, SWT.BORDER);
  // table.setHeaderVisible(true);
  // table.setLinesVisible(true);
  // TableColumn column0 = new TableColumn(table, SWT.NONE);
  // TableColumn column1 = new TableColumn(table, SWT.NONE);
  // TableColumn column2 = new TableColumn(table, SWT.NONE);
  // int minWidth = 0;
  // for (int i = 0; i < 100; i++)
  // {
  // TableItem item = new TableItem(table, SWT.NONE);
  // item.setText(new String[] { "item " + i, "asdadasd", "sada d asd asd a dasd" });
  // if (i % 3 == 0 || i % 5 == 0)
  // {
  // Button b = new Button(table, SWT.CHECK);
  // b.pack();
  // TableEditor editor = new TableEditor(table);
  // Point size = b.computeSize(SWT.DEFAULT, SWT.DEFAULT);
  // editor.minimumWidth = size.x;
  // minWidth = Math.max(size.x, minWidth);
  // editor.minimumHeight = size.y;
  // editor.horizontalAlignment = SWT.RIGHT;
  // editor.verticalAlignment = SWT.CENTER;
  // if (i % 3 == 0)
  // {
  // editor.setEditor(b, item, 1);
  // }
  // else
  // {
  // editor.setEditor(b, item, 2);
  // }
  // }
  // }
  // column0.pack();
  // column1.pack();
  // column1.setWidth(column1.getWidth() + minWidth);
  // column2.pack();
  // column2.setWidth(column2.getWidth() + minWidth);
  // shell.setSize(300, 300);
  // shell.open();
  // while (!shell.isDisposed())
  // {
  // if (!display.readAndDispatch())
  // display.sleep();
  // }
  // display.dispose();
  // }

  /**
   * This function will copy files or directories from one location to another. note that the source and the destination
   * must be mutually exclusive. This function can not be used to copy a directory to a sub directory of itself. The
   * function will also have problems if the destination files already exist.
   * 
   * @param src
   *          -- A File object that represents the source for the copy
   * @param dest
   *          -- A File object that represnts the destination for the copy.
   * @throws IOException
   *           if unable to copy.
   */
  public static void kopiereOrdnerDatei(File src, File dest, IProgressMonitor monitor, int cnt) throws IOException
  {
    // Check to ensure that the source is valid...
    if (!src.exists())
    {
      throw new IOException("copyFiles: Can not find source: " + src.getAbsolutePath() + ".");
    }
    else if (!src.canRead())
    { // check to ensure we have rights to the source...
      throw new IOException("copyFiles: No right to source: " + src.getAbsolutePath() + ".");
    }
    // is this a directory copy?

    if (src.isDirectory())
    {
      if (!dest.exists())
      {
        // does the destination already exist?
        // if not we need to make it exist if possible (note this is mkdirs not mkdir)
        if (!dest.mkdirs())
        {
          throw new IOException("copyFiles: Could not create direcotry: " + dest.getAbsolutePath() + ".");
        }
      }
      // get a listing of files...
      String list[] = src.list();
      // copy all the files in the list.

      monitor.beginTask("Erzeuge Ordnerstruktur", list.length);

      for (int i = 0; i < list.length; i++)
      {
        monitor.worked(i);

        File dest1 = new File(dest, list[i]);
        File src1 = new File(src, list[i]);

        // // Loop vermeiden!
        if (!src1.getAbsolutePath().equals(dest.getAbsolutePath()))
        {
          kopiereOrdnerDatei(src1, dest1, monitor, i);
        }
      }
    }
    else
    {
      monitor.worked(cnt);
      // This was not a directory, so lets just copy the file
      FileInputStream fin = null;
      FileOutputStream fout = null;
      byte[] buffer = new byte[4096]; // Buffer 4K at a time (you can change this).
      int bytesRead;
      try
      {
        // open the files for input and output
        fin = new FileInputStream(src);
        fout = new FileOutputStream(dest);
        // while bytesRead indicates a successful read, lets write...
        while ((bytesRead = fin.read(buffer)) >= 0)
        {
          fout.write(buffer, 0, bytesRead);
        }
      }
      catch (IOException e)
      { // Error copying file...
        IOException wrapper = new IOException("copyFiles: Unable to copy file: " + src.getAbsolutePath() + "to"
            + dest.getAbsolutePath() + ".");
        wrapper.initCause(e);
        wrapper.setStackTrace(e.getStackTrace());
        throw wrapper;
      }
      finally
      { // Ensure that the files are closed (if they were open).
        if (fin != null)
        {
          fin.close();
        }
        if (fout != null)
        {
          fout.close();
        }
      }
    }
  }

  public static boolean loescheVerzeichnis(File dir, IProgressMonitor monitor, int cnt)
  {
    if (dir.isDirectory())
    {
      String[] entries = dir.list();

      monitor.beginTask("Lsche Ordnerstruktur", cnt);

      for (int x = 0; x < entries.length; x++)
      {
        monitor.worked(x);

        File aktFile = new File(dir.getPath(), entries[x]);
        loescheVerzeichnis(aktFile, monitor, x);
      }

      if (dir.delete())
        return true;
      else
        return false;
    }
    else
    {
      monitor.worked(cnt);

      if (dir.delete())
        return true;
      else
        return false;
    }
  }

  public static int copyDir(File quelle, File ziel, IProgressMonitor monitor, Integer cnt, Integer max, boolean scharf)
      throws FileNotFoundException, IOException
  {
    File[] files = quelle.listFiles();

    if (scharf)
    {
      monitor.beginTask("Erzeuge Ordnerstruktur", max);
      ziel.mkdirs();
    }

    for (int i = 0; i < files.length; i++)
    {
      File file = files[i];

      if (file.isDirectory())
      {
        if (file.getName().equals("config") || file.getName().equals("xml"))
        {

          if (scharf)
          {
            monitor.worked(i);
          }

          cnt = copyDir(file, new File(ziel.getAbsolutePath() + System.getProperty("file.separator") + file.getName()),
              monitor, cnt, max, scharf);
          cnt++;

        }
      }
      else
      {
        if (file.getName().endsWith("verwaltungsdaten.xml"))
        {
          if (scharf)
          {
            monitor.worked(i);
          }

          copyFile(file, new File(ziel.getAbsolutePath() + System.getProperty("file.separator") + file.getName()),
              scharf);
          cnt++;

        }
      }
    }
    return cnt;
  }

  private static void copyFile(File file, File ziel, boolean scharf) throws FileNotFoundException, IOException
  {
    if (scharf)
    {
      BufferedInputStream in = new BufferedInputStream(new FileInputStream(file));
      BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(ziel, true));
      int bytes = 0;
      while ((bytes = in.read()) != -1)
      {
        out.write(bytes);
      }
      in.close();
      out.close();
    }

  }

}
