/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.assistenten;

import java.util.Date;

import org.eclipse.jface.dialogs.IDialogPage;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbench;

import de.bsvrz.buv.rw.basislib.kalender.DatumZeit;
import de.bsvrz.buv.rw.basislib.kalender.DatumZeit.Eingabetyp;

/**
 * Class representing the first page of the wizard
 */

public class InfoKonfigAenderungStartSeite extends WizardPage implements Listener
{
  private Shell shell;

  IWorkbench workbench;

  IStructuredSelection selection;

  private Label label;

  private String _version;

  private Label label1;

  private Text text1;

  private DatumZeit _datumZeit;

  private Label label2;

  private Text text2;

  private Label label3;

  private Text text3;

  private Label label4;

  private Text text4;

  private Label labelPid;

  private Text textPid;

  private Label labelName;

  private Text textName;

  private boolean _eingabePidNAme;

  /**
   * Constructor for HolidayMainPage.
   */
  public InfoKonfigAenderungStartSeite(boolean eingabePidName)
  {
    super("Page1");
    if (eingabePidName)
    {
      setTitle("KB Neu");
      setDescription("Eingabe der erforderlichen Daten");
    }
    _eingabePidNAme = eingabePidName;

  }

  /**
   * @see IDialogPage#createControl(Composite)
   */
  public void createControl(Composite parent)
  {
    shell = parent.getShell();
    Composite composite = new Composite(parent, SWT.NULL);
    // create the desired layout for this wizard page
    GridLayout gl = new GridLayout();
    int ncol = 2;
    gl.numColumns = ncol;
    composite.setLayout(gl);

    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.verticalAlignment = GridData.CENTER;
    GridData gridData2 = new GridData();
    gridData2.horizontalAlignment = GridData.FILL;
    gridData2.grabExcessHorizontalSpace = true;
    gridData2.verticalAlignment = GridData.CENTER;
    GridData gridData3 = new GridData();
    gridData3.horizontalAlignment = GridData.FILL;
    gridData3.grabExcessHorizontalSpace = true;
    gridData3.verticalAlignment = GridData.CENTER;
    GridData gridData4 = new GridData();
    gridData4.horizontalAlignment = GridData.FILL;
    gridData4.grabExcessHorizontalSpace = true;
    gridData4.verticalAlignment = GridData.CENTER;
    GridData gridData5 = new GridData();
    gridData5.horizontalAlignment = GridData.FILL;
    gridData5.grabExcessHorizontalSpace = true;
    gridData5.verticalAlignment = GridData.CENTER;

    InfoKonfigAenderungAssistent wizard = (InfoKonfigAenderungAssistent)getWizard();
    InfoKonfigAenderungModell model = wizard.getModel();

    labelPid = new Label(composite, SWT.NONE);
    labelPid.setText("Pid");
    textPid = new Text(composite, SWT.BORDER);
    textPid.setLayoutData(gridData2);
    textPid.setText(model._pid);
    textPid.setEnabled(_eingabePidNAme);
    labelName = new Label(composite, SWT.NONE);
    labelName.setText("Name");
    textName = new Text(composite, SWT.BORDER);
    textName.setLayoutData(gridData2);
    textName.setText(model._name);
    textName.setEnabled(_eingabePidNAme);

    label = new Label(composite, SWT.NONE);
    label.setText("Stand");
    _datumZeit = new DatumZeit(composite, SWT.BORDER, Eingabetyp.datumuhr, new Date(), false, false);
    _datumZeit.setLayoutData(gridData1);
    label1 = new Label(composite, SWT.NONE);
    label1.setText("Autor");
    text1 = new Text(composite, SWT.BORDER);
    text1.setLayoutData(gridData2);
    label3 = new Label(composite, SWT.NONE);
    label3.setText("Grund");
    text3 = new Text(composite, SWT.BORDER);
    text3.setLayoutData(gridData4);
    label4 = new Label(composite, SWT.NONE);
    label4.setText("Text");
    text4 = new Text(composite, SWT.BORDER);
    text4.setLayoutData(gridData5);

    createLine(composite, ncol);

    // set the composite as the control for this page
    setControl(composite);
    addListeners();

    _datumZeit.notifyListeners(SWT.Selection, new Event());
  }

  private void addListeners()
  {
    textPid.addListener(SWT.Modify, this);
    textName.addListener(SWT.Modify, this);
    _datumZeit.hinzufuegenSelektionsZuhoerer(new SelectionAdapter() {

      @Override
      public void widgetSelected(SelectionEvent e)
      {
        InfoKonfigAenderungAssistent wizard = (InfoKonfigAenderungAssistent)getWizard();
        InfoKonfigAenderungModell model = wizard.getModel();
        Date d = _datumZeit.getDatum();
        if (d != null)
        {
          model._stand = d.getTime();
        }
      }

    });
    text1.addListener(SWT.Modify, this);
    text3.addListener(SWT.Modify, this);
    text4.addListener(SWT.Modify, this);
  }

  /**
   * @see Listener#handleEvent(Event)
   */
  public void handleEvent(Event event)
  {
    boolean canFinish = false;
    
    if (_eingabePidNAme){
      if (isTextNonEmpty(textPid) && isTextNonEmpty(textName) && isTextNonEmpty(text1) && isTextNonEmpty(text3)
          /*&& isTextNonEmpty(text4)*/)
      {
        canFinish = true;
      }
    }else{
      if (isTextNonEmpty(text1) && isTextNonEmpty(text3)
          /*&& isTextNonEmpty(text4)*/)
      {
        canFinish = true;
      }
    }
    
    setPageComplete(canFinish);
    InfoKonfigAenderungAssistent wizard = ((InfoKonfigAenderungAssistent)getWizard());
    wizard.planeCompleted = canFinish;

    saveDataToModel();

    wizard.getContainer().updateButtons();
  }

  /**
   * @see IWizardPage#canFlipToNextPage()
   */
  public boolean canFlipToNextPage()
  {
    InfoKonfigAenderungAssistent wizard = ((InfoKonfigAenderungAssistent)getWizard());
    if (wizard.planeCompleted)
      return true;

    return false;
  }

  // /*
  // * Returns the next page. Saves the values from this page in the model associated with the wizard. Initializes the
  // * widgets on the next page.
  // */
  //
  public IWizardPage getNextPage()
  {
    saveDataToModel();

    InfoKonfigAenderungSeite1 planePage2 = ((InfoKonfigAenderungAssistent)getWizard()).planePage2;
    planePage2.onEnterPage();
    return planePage2;

  }

  /*
   * Saves the uses choices from this page to the model. Called on exit of the page
   */
  private void saveDataToModel()
  {
    // Gets the model
    InfoKonfigAenderungAssistent wizard = (InfoKonfigAenderungAssistent)getWizard();
    InfoKonfigAenderungModell model = wizard.getModel();

    model._pid = textPid.getText();
    model._name = textName.getText();
    model._autor = text1.getText();
    // model._version = text2.getText();
    model._grund = text3.getText();
    model._text = text4.getText();
  }

  private static boolean isTextNonEmpty(Text t)
  {
    if (t != null)
    {
      String s = t.getText();
      if ((s != null) && (s.trim().length() > 0))
        return true;
    }
    return false;
  }

  private void createLine(Composite parent, int ncol)
  {
    Label line = new Label(parent, SWT.SEPARATOR | SWT.HORIZONTAL | SWT.BOLD);
    GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
    gridData.horizontalSpan = ncol;
    line.setLayoutData(gridData);
  }

}
