/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.assistenten;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchWizard;

/**
 * Wizard class
 */
public class KbNeuAssistent extends Wizard implements INewWizard
{
  public static final String copyright = "(c) Copyright IBM Corporation 2002.";

  // wizard pages
  KbNeuStartSeite planePage;

  // the model
  KbNeuModell model;

  public KbNeuModell getModel()
  {
    return model;
  }

  public void setModel(KbNeuModell model)
  {
    this.model = model;
  }

  // workbench selection when the wizard was started
  protected IStructuredSelection selection;

  // flag indicated whether the wizard can be completed or not
  // if the user has selected plane as type of transport
  protected boolean planeCompleted = false;

  // flag indicated whether the wizard can be completed or not
  // if the user has selected car as type of transport
  protected boolean carCompleted = false;

  // the workbench instance
  protected IWorkbench workbench;

  private String _pidAoe;

  /**
   * Constructor for HolidayMainWizard.
   */
  public KbNeuAssistent(String pidAoe)
  {
    super();
    _pidAoe = pidAoe;
    model = new KbNeuModell();
  }

  public void addPages()
  {
    planePage = new KbNeuStartSeite(_pidAoe);
    addPage(planePage);
  }

  /**
   * @see IWorkbenchWizard#init(IWorkbench, IStructuredSelection)
   */
  public void init(IWorkbench workbench, IStructuredSelection selection)
  {
    this.workbench = workbench;
    this.selection = selection;
  }

  public boolean canFinish()
  {
    if (planeCompleted)
      return true;

    return false;
  }

  public boolean performFinish()
  {
    return true;
  }

}
