/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.assistenten;

import java.io.File;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.dialogs.IDialogPage;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbench;

/**
 * Class representing the first page of the wizard
 */

public class KbNeuStartSeite extends WizardPage implements Listener
{

  public static final String copyright = "(c) Copyright IBM Corporation 2002.";

  IWorkbench workbench;

  IStructuredSelection selection;

  Button kvButton;

  Button aoeButton;

  // status variable for the possible errors on this page
  // timeStatus holds an error if the return date is before the departure date
  IStatus timeStatus;

  // holds an error is the destination and departure fields are the same
  IStatus destinationStatus;

  private Label labelName;

  private Label labelBeschreibung;

  private Text textName;

  private Label labelQuelle;

  private Text textPid;

  private Label labelQuelle1;

//  private Text textOrtKonfig;
//
//  private Button button;

  private String _pidAoe;

  protected String _name;

  private Label labelQuelle2;

  private Text textOrtOrdner;

  private Button button2;

  private Label labelKodierung;

  private Text textKodierung;

  //
  // final static String[] dates = { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15",
  // "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31" };
  //
  // final static String[] months = { "January", "February", "March", "April", "May", "June", "July", "August",
  // "September", "October", "November", "December" };
  //
  // final static String[] years;
  //
  // final static int startingYear;

  private Shell shell;

  private File _source;

  private File _dest;

  // static
  // {
  // Calendar cal = Calendar.getInstance();
  // cal.setTime(new Date());
  // startingYear = cal.get(Calendar.YEAR);
  // years = new String[3];
  // for (int i = -1; i < 2; i++)
  // {
  // years[i + 1] = String.valueOf(startingYear + i);
  // }
  // }

  /**
   * Constructor for HolidayMainPage.
   */
  public KbNeuStartSeite(String pidAoe)
  {
    super("Page1");
    setTitle("Neuen KB anlegen");
    setDescription("Eingabe der erforderlichen Daten");
    destinationStatus = new Status(IStatus.OK, "not_used", 0, "", null);
    timeStatus = new Status(IStatus.OK, "not_used", 0, "", null);
    _pidAoe = pidAoe;

  }

  /**
   * @see IDialogPage#createControl(Composite)
   */
  public void createControl(Composite parent)
  {
    shell = parent.getShell();

    // create the composite to hold the widgets
    GridData gd;
    Composite composite = new Composite(parent, SWT.NULL);

    // create the desired layout for this wizard page
    GridLayout gl = new GridLayout();
    int ncol = 3;
    gl.numColumns = ncol;
    composite.setLayout(gl);

    GridData gridData21 = new GridData();
    gridData21.horizontalAlignment = GridData.FILL;
    gridData21.grabExcessHorizontalSpace = true;
    gridData21.verticalAlignment = GridData.CENTER;
    GridData gridData110 = new GridData();
    gridData110.horizontalAlignment = GridData.FILL;
    gridData110.grabExcessHorizontalSpace = true;
    gridData110.verticalAlignment = GridData.CENTER;
    GridData gridData111 = new GridData();
    gridData111.horizontalAlignment = GridData.FILL;
    gridData111.grabExcessHorizontalSpace = true;
    gridData111.verticalAlignment = GridData.CENTER;
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.verticalAlignment = GridData.CENTER;
    labelName = new Label(composite, SWT.NONE);
    labelName.setText("Name");
    textName = new Text(composite, SWT.BORDER);
    textName.setLayoutData(gridData1);
    // if (_pidAoe != null)
    // textName.setText(_pidAoe);
    // textName.setEnabled(false);
    Label filler0 = new Label(composite, SWT.NONE);
     labelKodierung = new Label(composite, SWT.NONE);
     labelKodierung.setText("Pid");
     textKodierung = new Text(composite, SWT.BORDER);
     textKodierung.setLayoutData(gridData111);
//     textKodierung.setEnabled(false);
     Label filler1 = new Label(composite, SWT.NONE);
    // labelBeschreibung = new Label(composite, SWT.NONE);
    // labelBeschreibung.setText("Name");
    // textName = new Text(composite, SWT.BORDER);
    // textName.setLayoutData(gridData110);
    // Label filler = new Label(composite, SWT.NONE);
    // labelQuelle = new Label(composite, SWT.NONE);
    // labelQuelle.setText("Pid");
    // textPid = new Text(composite, SWT.BORDER);
    // textPid.setLayoutData(gridData1);
    // Label filler2 = new Label(composite, SWT.NONE);

//    labelQuelle1 = new Label(composite, SWT.NONE);
//    labelQuelle1.setText("Ablageort *.config-Datei");
//    textOrtKonfig = new Text(composite, SWT.BORDER);
//    textOrtKonfig.setLayoutData(gridData21);
//    button = new Button(composite, SWT.NONE);
//    button.setText("...");

    createLine(composite, ncol);

    // set the composite as the control for this page
    setControl(composite);
    addListeners();
  }

  private void addListeners()
  {
    // textKodierung.addListener(SWT.Modify, this);
    textName.addListener(SWT.Modify, this);
    textKodierung.addListener(SWT.Modify, this);
//    textOrtKonfig.addListener(SWT.Modify, this);
//    button.addListener(SWT.Selection, this);
  }

  /**
   * @see Listener#handleEvent(Event)
   */
  public void handleEvent(Event event)
  {
    // Initialize a variable with the no error status
    Status status = new Status(IStatus.OK, "not_used", 0, "", null);
    // If the event is triggered by the destination or departure fields
    // set the corresponding status variable to the right value

//    if ((event.widget == button))
//    {
//      DirectoryDialog dlg = new DirectoryDialog(shell);
//     
//      dlg.setText("Ordner-Auswahl Dialog");
//
//      dlg.setMessage("Ordner auswhlen");
//      
//      String dir = dlg.open();
//      if (dir != null)
//      {
//        if (event.widget == button)
//          textOrtKonfig.setText(dir);
//      }
//    }
    
    if (isTextNonEmpty(textName) && isTextNonEmpty(textKodierung))
    {
        setPageComplete(true);
        KbNeuAssistent wizard = ((KbNeuAssistent)getWizard());
        wizard.planeCompleted = true;
        
    }else
      setPageComplete(false);

    

    // // Show the most serious error
    // applyToStatusLine(findMostSevere());
    
    saveDataToModel();
    
    getWizard().getContainer().updateButtons();
  }

  /**
   * @see IWizardPage#canFlipToNextPage()
   */
  public boolean canFlipToNextPage()
  {
    if (getErrorMessage() != null)
      return false;

    return false;
  }

  /*
   * Saves the uses choices from this page to the model. Called on exit of the page
   */
  private void saveDataToModel()
  {
    // Gets the model
    KbNeuAssistent wizard = (KbNeuAssistent)getWizard();
    KbNeuModell model = wizard.getModel();

    model._name = textName.getText();
//    model._quellVerzeichnis = textOrtKonfig.getText();
    model._pid = textKodierung.getText();
  }

  private static boolean isTextNonEmpty(Text t)
  {
    if (t != null)
    {
      String s = t.getText();
      if ((s != null) && (s.trim().length() > 0))
        return true;
    }
    return false;
  }

  private void createLine(Composite parent, int ncol)
  {
    Label line = new Label(parent, SWT.SEPARATOR | SWT.HORIZONTAL | SWT.BOLD);
    GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
    gridData.horizontalSpan = ncol;
    line.setLayoutData(gridData);
  }

}
