/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.assistenten;

import java.util.HashMap;
import java.util.Map;

import de.bsvrz.puk.config.configFile.datamodel.ConfigDataModel;

/**
 * Model class containing the data for the holiday wizard
 */
public class KvAoeNeuModell
{
  public static final String copyright = "(c) Copyright IBM Corporation 2002.";

  // date of departure as a String day, month, year
  protected String _pid = "";

  // flight details for the holiday by plane
  protected String _name = "";

  public String getName()
  {
    return _name;
  }

  public String getQuellVerzeichnis()
  {
    return _quellVerzeichnis;
  }

  public boolean isUseKV()
  {
    return useKV;
  }

  public boolean isUseAOE()
  {
    return useAOE;
  }

  // flight details for the holiday by plane
  protected String _kodierung = "";

  // date of return as a String day, month, year
  protected String _quellVerzeichnis = "";

  // holiday destination
  protected String _zielVerzeichnis = "";

  // holiday destination
  protected String _configVerzeichnis = "";

  // flag indicating whether the user will use the plane
  protected boolean useKV = true;

  // true if the flisgts need to be reset
  protected boolean useAOE = false;

  // true if the flisgts need to be reset
  protected String _info = "";

  // true if the flisgts need to be reset
  protected String _beschreibung = "";
  
  // true if the flisgts need to be reset
  protected String _infoDef = "";
  
  public String getInfoDef()
  {
    return _infoDef;
  }

  public String getBeschreibungDef()
  {
    return _beschreibungDef;
  }

  // true if the flisgts need to be reset
  protected String _beschreibungDef = "";

  // true if the flisgts need to be reset
  protected Map<String, String> _mengen = new HashMap<String, String>();

  protected ConfigDataModel _config;

  protected Thread _autoCloser;

  public Thread getAutoCloser()
  {
    return _autoCloser;
  }

  public Map<String, String> getMengen()
  {
    return _mengen;
  }

  public String toString()
  {
    String s;
    s = "KV/AOE neu erstellen: \n";
    if (useKV)
      s = s + "KV neu: ";
    else
      s = s + "AOE neu: ";

    if (useKV)
      s = s + "\npid: " + _pid + "\nname: " + _name + "\nziel: " + _zielVerzeichnis + "\nquelle: " + _quellVerzeichnis
          + "\nconfig: " + _configVerzeichnis + "\ninfo: " + _info;
    else
    {
      s = s + "\npid: " + _pid + "\nname: " + "\nkodierung: " + _kodierung + _name + "\nziel: " + _zielVerzeichnis
          + "\nquelle: " + _quellVerzeichnis + "\nVerzeichnis: " + _configVerzeichnis + "\ninfo: " + _info + "\nconfig: " + _config;

      for (int i = 0; i < _mengen.size(); i++)
      {
        String menge = _mengen.get(i);
        s = s + "\n menge: " + menge;
      }
    }
    return s;
  }

  public String getZielVerzeichnis()
  {
    return _zielVerzeichnis;
  }

  public String getPid()
  {
    return _pid;
  }

  public String getKurzInfo()
  {
    // TODO Auto-generated method stub
    return _info;
  }

  public String getBeschreibung()
  {
    // TODO Auto-generated method stub
    return _beschreibung;
  }

  public String getKodierung()
  {
    // TODO Auto-generated method stub
    return _kodierung;
  }
  
  public ConfigDataModel getConfig()
  {
    // TODO Auto-generated method stub
    return _config;
  }

}
