/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.assistenten;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.net.URI;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.MultiStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.IDialogPage;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITableColorProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbench;

import de.bsvrz.buv.plugin.konfigass.Activator;
import de.bsvrz.buv.plugin.konfigass.MeldungenSpeicher;
import de.bsvrz.buv.plugin.konfigass.managementfile.MyConfigurationAreaManagementInfo;
import de.bsvrz.buv.plugin.konfigass.managementfile.MyConfigurationManagementFile;
import de.bsvrz.buv.plugin.konfigass.managementfile.MyManagementFile;
import de.bsvrz.dav.daf.main.config.ObjectSetUse;
import de.bsvrz.dav.daf.main.config.SystemObjectType;
import de.bsvrz.puk.config.configFile.datamodel.ConfigDataModel;

/**
 * Class representing the first page of the wizard
 */

public class KvAoeNeuSeite2 extends WizardPage
{

  IWorkbench workbench;

  protected Button kvButton;

  protected Button aoeButton;

  private String _pidAoe;

  protected String _name;

  private Shell shell;

  private TableViewer _tvZufluesse1;

  private SortedMap<String, Object[]> _mapMengen;

//  private ConfigDataModel _config;
//
//  private Thread _tAutoCloser;

  private MultiStatus _status;

  private Button cancelButton;

  /**
   * Constructor for HolidayMainPage.
   */
  public KvAoeNeuSeite2(String pidAoe)
  {
    super("Page2");
    setTitle("Neuer KV/AOE anlegen");
    setDescription("Schritt 3 : Auswahl der Mengen");
    _pidAoe = pidAoe;

  }

  /**
   * @see IDialogPage#createControl(Composite)
   */
  public void createControl(Composite parent)
  {
    shell = parent.getShell();

    // create the composite to hold the widgets
    GridData gd;
    Composite composite = new Composite(parent, SWT.NULL);

    // create the desired layout for this wizard page
    GridLayout gl = new GridLayout();
    int ncol = 1;
    gl.numColumns = ncol;
    composite.setLayout(new GridLayout());

    GridData gridData21 = new GridData();
    gridData21.horizontalAlignment = GridData.FILL;
    gridData21.grabExcessHorizontalSpace = true;
    gridData21.verticalAlignment = GridData.CENTER;
    GridData gridData110 = new GridData();
    gridData110.horizontalAlignment = GridData.FILL;
    gridData110.grabExcessHorizontalSpace = true;
    gridData110.verticalAlignment = GridData.CENTER;
    GridData gridData111 = new GridData();
    gridData111.horizontalAlignment = GridData.FILL;
    gridData111.grabExcessHorizontalSpace = true;
    gridData111.verticalAlignment = GridData.CENTER;
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.verticalAlignment = GridData.CENTER;

    erzeugeTabelleTeilkonfigurationsassistenten(composite);

    // _mapMengen = new HashMap<String, Object[]>();
    //
    // Object[] oo1 = new Object[2];
    // oo1[0] = "menge.puaSkripte";
    // oo1[1] = true;
    // _mapMengen.put("PuaSkripte", oo1);
    //
    // Object[] oo2 = new Object[2];
    // oo2[0] = "menge.ereignisTypen";
    // oo2[1] = true;
    // _mapMengen.put("EreignisTypen", oo2);
    //
    // Object[] oo3 = new Object[2];
    // oo3[0] = "menge.simulationsStrecken";
    // oo3[1] = true;
    // _mapMengen.put("SimulationsStrecken", oo3);
    //
    // Object[] oo4 = new Object[2];
    // oo4[0] = "menge.simulationen";
    // oo4[1] = true;
    // _mapMengen.put("Simulationen", oo4);
    //
    // Object[] oo5 = new Object[2];
    // oo5[0] = "menge.systemKalenderEintrge";
    // oo5[1] = true;
    // _mapMengen.put("SystemKalenderEintrge", oo5);
    //
    // Object[] oo6 = new Object[2];
    // oo6[0] = "menge.ereignisse";
    // oo6[1] = true;
    // _mapMengen.put("Ereignisse", oo6);
    //
    // // Object[] oo7 = new Object[2];
    // // oo7[0] = "menge.meldungen";
    // // oo7[1] = false;
    // // _mapMengen.put("Meldungen", oo7);
    //
    // for (Map.Entry<String, Object[]> me : _mapMengen.entrySet())
    // {
    //
    // TableItem ti = new TableItem(_tvZufluesse1.getTable(), SWT.NONE);
    // ti.setText(1, me.getKey());
    // ti.setChecked((Boolean)me.getValue()[1]);
    // ti.setData((Boolean)me.getValue()[1]);
    // if ((Boolean)me.getValue()[1])
    // ti.setForeground(new Color(null, 209, 209, 209));
    // }

    createLine(composite, ncol);

    // Choice of transport
    kvButton = new Button(composite, SWT.RADIO);
    kvButton.setText("Konfigurationsverantwortlicher");
    gd = new GridData(GridData.FILL_HORIZONTAL);
    gd.horizontalSpan = ncol;
    kvButton.setLayoutData(gd);
    // kvButton.setSelection(true);
    kvButton.setEnabled(false);

    aoeButton = new Button(composite, SWT.RADIO);
    aoeButton.setText("Autarke Organisations Einheit");
    gd = new GridData(GridData.FILL_HORIZONTAL);
    gd.horizontalSpan = ncol;
    aoeButton.setLayoutData(gd);
    aoeButton.setEnabled(false);

    // set the composite as the control for this page
    setControl(composite);
    // addListeners();
    
    WizardDialog2 container = (WizardDialog2)getContainer();
    cancelButton = container.getButton(IDialogConstants.CANCEL_ID);    

    parent.layout(true);
  }

  private void erzeugeTabelleTeilkonfigurationsassistenten(Composite parent)
  {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.FILL;
    gridData.grabExcessVerticalSpace = true;

    Composite composite = new Composite(parent, SWT.NONE);
    composite.setLayout(new GridLayout());
    composite.setLayoutData(gridData);

    _tvZufluesse1 = new TableViewer(composite, SWT.CHECK | SWT.FULL_SELECTION | SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
    _tvZufluesse1.setContentProvider(new TabelleTeilkonfigurationsassistentenInhaltsVersorger());
    // _tvZufluesse1.setLabelProvider(new TabelleTeilkonfigurationsassistentenDarstellungsVersorger());

    TableViewerColumn tc1 = new TableViewerColumn(_tvZufluesse1, SWT.NONE);
    tc1.getColumn().setWidth(20);
    tc1.getColumn().setText("Auswahl");

    TableViewerColumn tc2 = new TableViewerColumn(_tvZufluesse1, SWT.NONE);
    tc2.getColumn().setWidth(200);
    tc2.getColumn().setText("Menge");

    _tvZufluesse1.getTable().setLayout(new FillLayout());
    GridData gd2 = new GridData(GridData.FILL_BOTH);
    _tvZufluesse1.getTable().setLayoutData(gd2);

  }

  private void addListeners()
  {
    // textInfo.addListener(SWT.Modify, this);
    // textOrtOrdner.addListener(SWT.Selection, this);
    // button2.addListener(SWT.Selection, this);

    // kvButton.addListener(SWT.Selection, this);
    // aoeButton.addListener(SWT.Selection, this);
  }

  //
  // /**
  // * @see Listener#handleEvent(Event)
  // */
  public void handleEvent(Event event)
  {
    // Initialize a variable with the no error status
    Status status = new Status(IStatus.OK, "not_used", 0, "", null);
    // If the event is triggered by the destination or departure fields
    // set the corresponding status variable to the right value

    setPageComplete(isPageComplete());
    getWizard().getContainer().updateButtons();
  }

  // /*
  // * Returns the next page. Saves the values from this page in the model associated with the wizard. Initializes the
  // * widgets on the next page.
  // */
  //
  public IWizardPage getNextPage()
  {
    saveDataToModel();

    // if (_config != null)
    // _config.close();

    // if (kvButton.getSelection())
    {
      KvAoeNeuSeite3 page3 = ((KvAoeNeuAssistent)getWizard()).seite3;
      page3.onEnterPage();
      return page3;

    }
  }

  /**
   * @see IWizardPage#canFlipToNextPage()
   */
  public boolean canFlipToNextPage()
  {

    if (getErrorMessage() != null)
      return false;

    TableItem[] items = _tvZufluesse1.getTable().getItems();

    boolean flag = false;

    for (TableItem ti : items)
    {
      if (ti.getChecked())
        flag = true;
    }

    return true;
  }

  /*
   * Saves the uses choices from this page to the model. Called on exit of the page
   */
  private void saveDataToModel()
  {
    KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
    KvAoeNeuModell model = wizard.model;

    for (Map.Entry<String, Object[]> me : _mapMengen.entrySet())
    {
      String set = me.getKey();
      Object[] oo = me.getValue();
      String typ = (String)oo[0];
      Boolean required = (Boolean)oo[1];

      if (required)
        model._mengen.put(set, typ);

    }

//    if (model._config == null)
//    {
//      model._config = _config;
//
//    }
//
//    if (model._autoCloser == null)
//    {
//      model._autoCloser = _tAutoCloser;
//    }
  }

  /*
   * Sets the completed field on the wizard class when all the information is entered and the wizard can be completed
   */
  public boolean isPageComplete()
  {
    KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
    wizard.seite2Complete = true;
    return true;
  }

  private static boolean isTextNonEmpty(Text t)
  {
    if (t != null)
    {
      String s = t.getText();
      if ((s != null) && (s.trim().length() > 0))
        return true;
    }
    return false;
  }

  private void createLine(Composite parent, int ncol)
  {
    Label line = new Label(parent, SWT.SEPARATOR | SWT.HORIZONTAL | SWT.BOLD);
    GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
    gridData.horizontalSpan = ncol;
    line.setLayoutData(gridData);
  }

  void onEnterPage()
  {
    // Gets the model
    KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
    KvAoeNeuModell model = wizard.model;

    String ziel = model.getZielVerzeichnis();
    String pfad = ziel + "/config/verwaltungsdaten.xml";

    MyConfigurationManagementFile managementFile = new MyManagementFile(new File(pfad));

    List<MyConfigurationAreaManagementInfo> camis = managementFile.getAllMyConfigurationAreaManagementInfos();
    String q = model.getQuellVerzeichnis();
    String z = model.getZielVerzeichnis();

    // System.out.println("Quelle: " + q);
    // System.out.println("Ziel: " + z);

    for (MyConfigurationAreaManagementInfo cami : camis)
    {
      String pid = cami.getPid();
      File dir = cami.getDirectory();

      String s1 = dir.getPath();

      if (s1.contains(z))
      {
        String s2 = s1.replace(z, q);

        URI uriBase = new File(s1.replace("\\", "/")).toURI();
        URI uriRelative = new File(s2.replace("\\", "/")).toURI();

        URI uri = uriBase.relativize(uriRelative);
        // System.out.println("URIRelativized: " + uri);
        try
        {
          cami.setDirectory(new File(uri).getCanonicalFile());
          cami.delAllVersionInfo();
        }
        catch (IOException e)
        {
          // TODO Auto-generated catch block
          e.printStackTrace();
        }

      }
    }

    try
    {
      managementFile.save();
      managementFile.close();

      _mapMengen = new TreeMap<String, Object[]>();

      _mapMengen = bestimmeMengen(pfad);

      // if (_mapMengen != null)
      {
        for (Map.Entry<String, Object[]> me : _mapMengen.entrySet())
        {

          TableItem ti = new TableItem(_tvZufluesse1.getTable(), SWT.NONE);
          ti.setText(1, me.getKey());
          ti.setData("required", (Boolean)me.getValue()[1]);

          Boolean r = (Boolean)ti.getData("required");

          ti.setChecked(r);
          if ((Boolean)me.getValue()[1])
            ti.setForeground(new Color(null, 209, 209, 209));
        }

        Table table = _tvZufluesse1.getTable();

        table.addListener(SWT.Selection, new Listener() {
          public void handleEvent(Event event)
          {
            if (event.detail == SWT.CHECK)
            {

              if (event.item.getData("required") instanceof Boolean)
              {

                Boolean b = (Boolean)event.item.getData("required");

                if (b)
                {
                  event.detail = SWT.NONE;
                  event.type = SWT.None;
                  event.doit = false;
                  try
                  {
                    // table.setRedraw(false);
                    TableItem item = (TableItem)event.item;
                    item.setChecked(!item.getChecked());
                  }
                  finally
                  {
                    // table.setRedraw(true);
                  }
                }
                else
                {
                  TableItem item = (TableItem)event.item;
                  String key = item.getText(1);

                  Object[] oo = _mapMengen.get(key);
                  oo[1] = item.getChecked();
                  _mapMengen.put(key, oo);

                }
              }
            }
          }
        });

      }

    }
    catch (IOException e)
    {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }

    if (model.useAOE)
    {
      // textKodierung.setEnabled(true);
      aoeButton.setSelection(true);
      kvButton.setSelection(false);
    }
    else
    {
      // textKodierung.setEnabled(false);
      aoeButton.setSelection(false);
      kvButton.setSelection(true);
    }

  }

  /**
   * @author Pittner
   * 
   */
  private class TabelleTeilkonfigurationsassistentenInhaltsVersorger implements IStructuredContentProvider
  {

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
     */
    public Object[] getElements(Object inputElement)
    {
      java.util.List list = (java.util.List)inputElement;

      Object[] re = new Object[list.size()];

      for (int i = 0; i < list.size(); i++)
      {
        re[i] = list.get(i);
      }

      return re;
    }

    /*
     * (non-Javadoc) *
     * 
     * @see org.eclipse.jface.viewers.IContentProvider#dispose()
     */
    public void dispose()
    {

    }

    /*
     * (non-Javadoc) *
     * 
     * @see org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface.viewers.Viewer, java.lang.Object,
     * java.lang.Object)
     */
    public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
    {

    }
  }

  /**
   * {@link LabelProvider} fr die Tabelle.
   * 
   * @author HofmannJ
   * 
   */
  private class TabelleTeilkonfigurationsassistentenDarstellungsVersorger implements ITableLabelProvider,
      ITableColorProvider
  {

    @Override
    public Image getColumnImage(Object element, int columnIndex)
    {
      return null;
    }

    @Override
    public String getColumnText(Object element, int columnIndex)
    {
      String returnString = null;

      switch (columnIndex)
      {
        case 0:
          returnString = "";
          break;
        case 1:
          returnString = (String)element;
          break;
        default:
          returnString = "default";
      }
      return returnString;
    }

    @Override
    public void addListener(ILabelProviderListener listener)
    {
    }

    @Override
    public void dispose()
    {
    }

    @Override
    public boolean isLabelProperty(Object element, String property)
    {
      return false;
    }

    @Override
    public void removeListener(ILabelProviderListener listener)
    {
    }

    @Override
    public Color getBackground(Object element, int columnIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }

    @Override
    public Color getForeground(Object element, int columnIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }

  }

  private SortedMap<String, Object[]> bestimmeMengen(final String pfad)
  {
    ladeDatenmodellAssistent(pfad);

    KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
    KvAoeNeuModell model = wizard.model;
    
    if (model._config != null)
    {
      SystemObjectType type = model._config.getType("typ.autarkeOrganisationsEinheit");

      List<ObjectSetUse> sets = type.getObjectSetUses();

      for (ObjectSetUse osu : sets)
      {

        Object[] o = new Object[2];

        String typ = osu.getObjectSetType().getPidOrNameOrId();
        String name = osu.getObjectSetName();

        o[0] = typ;
        o[1] = osu.isRequired();
        _mapMengen.put(name, o);

      }
    }

    // TODO Auto-generated method stub
    return _mapMengen;
  }

//  private void ladeDatenmodellAssistent(final String pfad)
//  {
//    IRunnableWithProgress op2 = new IRunnableWithProgress() {
//
//      private MultiStatus _status;
//
//      @Override
//      public void run(IProgressMonitor monitor) throws InvocationTargetException, InterruptedException
//      {
//
//        monitor.beginTask("Lade Datenmodell / Bestimme Mengen", 1);
//
//        try
//        {
//          _status = new MultiStatus(Activator.PLUGIN_ID, Status.OK, "Starte Laden des Datenmodells", null);
//          MeldungenSpeicher.getInstanz().setStatus(_status);
//
//          File file = new File(pfad);
//
//          _config = erzeugeKonfigDatenModellAusDatei(file);
//          monitor.worked(1);
//          if (_config != null)
//            _status.add(new Status(Status.OK, Activator.PLUGIN_ID, "Laden Datenmodell erfolgreich abgeschlossen. "));
//        }
//        catch (Exception e)
//        {
//          _status.add(new Status(Status.ERROR, Activator.PLUGIN_ID,
//              "Aktion Laden Datenmodell fehlgeschlagen, die evt. geladene Konfiguration wurde geschlossen. "));
//        }
//        finally
//        {
//          MeldungenSpeicher.getInstanz().hinzufuegenMultimeldung(_status, System.currentTimeMillis(), true);
//          monitor.done();
//        }
//      }
//    };
//    try
//    {
//      WizardDialog2 container = (WizardDialog2)getContainer();
//      container.run(true, true, op2);
//    }
//    catch (InvocationTargetException e)
//    {
//      // TODO Auto-generated catch block
//      e.printStackTrace();
//    }
//    catch (InterruptedException e)
//    {
//      // TODO Auto-generated catch block
//      e.printStackTrace();
//    }
//  }
  
  public void ladeDatenmodellAssistent(final String pfad)
  {
    IRunnableWithProgress op2 = new IRunnableWithProgress() {

      private MultiStatus _status;

      @Override
      public void run(IProgressMonitor monitor) throws InvocationTargetException, InterruptedException
      {

        KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
        KvAoeNeuModell model = wizard.model;
        
        if (model.useKV)
          monitor.beginTask("Lade Datenmodell", 5);
        else monitor.beginTask("Lade Datenmodell / Bestimme Mengen", 5);
        
        monitor.worked(1);

        try
        {
          _status = new MultiStatus(Activator.PLUGIN_ID, Status.OK, "Starte Laden des Datenmodells", null);
          MeldungenSpeicher.getInstanz().setStatus(_status);

          File file = new File(pfad);

          
          Display.getDefault().asyncExec(new Runnable() {
            
            @Override
            public void run()
            {
              cancelButton.setEnabled(false);                        
            }
          });
          
          model._config = erzeugeKonfigDatenModellAusDatei(file);
                    
          monitor.worked(1);
          
          if (model._config != null){                                      
            _status.add(new Status(Status.OK, Activator.PLUGIN_ID, "Laden Datenmodell erfolgreich abgeschlossen. "));
          }
        }
        catch (Exception e)
        {
          _status.add(new Status(Status.ERROR, Activator.PLUGIN_ID,
              "Aktion Laden Datenmodell fehlgeschlagen, die evt. geladene Konfiguration wurde geschlossen. "));
        }
        finally
        {
          Display.getDefault().asyncExec(new Runnable() {
            
            @Override
            public void run()
            {
              cancelButton.setEnabled(true);                        
            }
          });
          
          MeldungenSpeicher.getInstanz().hinzufuegenMultimeldung(_status, System.currentTimeMillis(), true);
          monitor.worked(3);
          monitor.done();
        }
      }
    };
    try
    {
      WizardDialog2 container = (WizardDialog2)getContainer();
      container.run(true, true, op2);
    }
    catch (InvocationTargetException e)
    {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
    catch (InterruptedException e)
    {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
  }

  /**
   * Erzeugt das Offline-Datenmodell der Konfiguration aus der XML-Verwaltungsdatei
   * 
   * @param configurationFile
   *          die Verwaltungsdatei
   * @return das Offline-Datenmodell
   */
  public ConfigDataModel erzeugeKonfigDatenModellAusDatei(File configurationFile)
  {
    try
    {
      final ConfigDataModel configuration = new ConfigDataModel(configurationFile);

      Runnable autoCloser = new Runnable() {
        public void run()
        {
          configuration.close();
        }
      };

      KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
      KvAoeNeuModell model = wizard.model;
      
      if (model._autoCloser != null){
        Runtime.getRuntime().removeShutdownHook(model._autoCloser);        
      }
      
      model._autoCloser = new Thread(autoCloser);
      Runtime.getRuntime().addShutdownHook(model._autoCloser);

      return configuration;
    }
    catch (Exception e)
    {
      _status = new MultiStatus(Activator.PLUGIN_ID, Status.OK, "Fehler beim Laden des Datenmodells", e);
      MeldungenSpeicher.getInstanz().setStatus(_status);
    }
    return null;

  }

}
