/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.assistenten;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.net.URI;
import java.util.List;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.MultiStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.IDialogPage;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbench;

import de.bsvrz.buv.plugin.konfigass.Activator;
import de.bsvrz.buv.plugin.konfigass.MeldungenSpeicher;
import de.bsvrz.buv.plugin.konfigass.managementfile.MyConfigurationAreaManagementInfo;
import de.bsvrz.buv.plugin.konfigass.managementfile.MyConfigurationManagementFile;
import de.bsvrz.buv.plugin.konfigass.managementfile.MyManagementFile;
import de.bsvrz.puk.config.configFile.datamodel.ConfigDataModel;

/**
 * Class representing the first page of the wizard
 */

public class KvAoeNeuSeite3 extends WizardPage implements Listener
{

  IWorkbench workbench;

  IStructuredSelection selection;

  Button kvButton;

  Button aoeButton;

  // status variable for the possible errors on this page
  // timeStatus holds an error if the return date is before the departure date
  IStatus timeStatus;

  // holds an error is the destination and departure fields are the same
  IStatus destinationStatus;

  private String _pidAoe;

  protected String _name;

  private Label labelInfo;

  private Shell shell;

  private Text textInfo;

  private Label _labelInfo;

  private Label _labelInfo2;

  private StyledText textInfo2;

  private Label _labelInfoAOE;

  private Text textInfoAOE;

  private Label _labelInfo2AOE;

  private Text textInfo2AOE;

//  private ConfigDataModel _config;

//  private Thread _tAutoCloser;

  private MultiStatus _status;

  private Button cancelButton;

  private Button backButton;

  /**
   * Constructor for HolidayMainPage.
   */
  public KvAoeNeuSeite3(String pidAoe)
  {
    super("Seite2");
    setTitle("Neuer KV/AOE anlegen");
    setDescription("Zustzliche Informationen");
    destinationStatus = new Status(IStatus.OK, "not_used", 0, "", null);
    timeStatus = new Status(IStatus.OK, "not_used", 0, "", null);
    _pidAoe = pidAoe;
 
  }

  /**
   * @see IDialogPage#createControl(Composite)
   */
  public void createControl(Composite parent)
  {
    GridData gridData = new GridData();
    gridData.horizontalAlignment = GridData.FILL;
    gridData.grabExcessHorizontalSpace = true;
    gridData.verticalAlignment = GridData.CENTER;

    shell = parent.getShell();

    // create the composite to hold the widgets
    GridData gd;
    Composite composite = new Composite(parent, SWT.NULL);

    // create the desired layout for this wizard page
    GridLayout gl = new GridLayout();
    int ncol = 2;
    gl.numColumns = ncol;
    composite.setLayout(gl);

    GridData gridData21 = new GridData();
    gridData21.horizontalAlignment = GridData.FILL;
    gridData21.grabExcessHorizontalSpace = true;
    gridData21.verticalAlignment = GridData.CENTER;
    GridData gridData110 = new GridData();
    gridData110.horizontalAlignment = GridData.FILL;
    gridData110.grabExcessHorizontalSpace = true;
    gridData110.verticalAlignment = GridData.CENTER;
    GridData gridData111 = new GridData();
    gridData111.horizontalAlignment = GridData.FILL;
    gridData111.grabExcessHorizontalSpace = true;
    gridData111.verticalAlignment = GridData.CENTER;
    GridData gridData1 = new GridData();
    gridData1.horizontalAlignment = GridData.FILL;
    gridData1.grabExcessHorizontalSpace = true;
    gridData1.verticalAlignment = GridData.CENTER;

    _labelInfo = new Label(composite, SWT.NONE);
    _labelInfo.setText("Kurzinfo");
    textInfo = new Text(composite, SWT.BORDER);
    textInfo.setLayoutData(new GridData(GridData.FILL_HORIZONTAL | GridData.GRAB_HORIZONTAL));
    _labelInfo2 = new Label(composite, SWT.NONE);
    _labelInfo2.setText("Beschreibung");
    _labelInfo2.setLayoutData(new GridData(GridData.FILL_VERTICAL | GridData.VERTICAL_ALIGN_BEGINNING));
    textInfo2 = new StyledText(composite, SWT.BORDER | SWT.MULTI);
    textInfo2.setLayoutData(new GridData(GridData.FILL_BOTH | GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL));

    KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();

    KvAoeNeuModell model = wizard.model;

    // if (!model.useKV)
    {
      _labelInfoAOE = new Label(composite, SWT.NONE);
      _labelInfoAOE.setText("Kurzinfo Def.-Bereich");
      textInfoAOE = new Text(composite, SWT.BORDER);
      textInfoAOE.setLayoutData(new GridData(GridData.FILL_HORIZONTAL | GridData.GRAB_HORIZONTAL));
      _labelInfo2AOE = new Label(composite, SWT.NONE);
      _labelInfo2AOE.setText("Beschr. Def.-Bereich");
      _labelInfo2AOE.setLayoutData(new GridData(GridData.FILL_VERTICAL | GridData.VERTICAL_ALIGN_BEGINNING));
      textInfo2AOE = new Text(composite, SWT.BORDER | SWT.MULTI);
      textInfo2AOE.setLayoutData(new GridData(GridData.FILL_BOTH | GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL));
    }

    createLine(composite, ncol);

    // Choice of transport
    kvButton = new Button(composite, SWT.RADIO);
    kvButton.setText("Konfigurationsverantwortlicher");
    gd = new GridData(GridData.FILL_HORIZONTAL);
    gd.horizontalSpan = ncol;
    kvButton.setLayoutData(gd);
    // kvButton.setSelection(true);
    kvButton.setEnabled(false);

    aoeButton = new Button(composite, SWT.RADIO);
    aoeButton.setText("Autarke Organisations Einheit");
    gd = new GridData(GridData.FILL_HORIZONTAL);
    gd.horizontalSpan = ncol;
    aoeButton.setLayoutData(gd);
    aoeButton.setEnabled(false);
    
    WizardDialog2 container = (WizardDialog2)getContainer();
    cancelButton = container.getButton(IDialogConstants.CANCEL_ID);
    backButton = container.getButton(IDialogConstants.BACK_ID);

    // set the composite as the control for this page
    setControl(composite);
    addListeners();

  }

  private void addListeners()
  {
    textInfo.addListener(SWT.Modify, this);
    textInfo2.addListener(SWT.Modify, this);
    textInfoAOE.addListener(SWT.Modify, this);
    textInfo2AOE.addListener(SWT.Modify, this);
    backButton.addListener(SWT.Selection, this);
  }

  /**
   * @see Listener#handleEvent(Event)
   */
  public void handleEvent(Event event)
  {
    // Initialize a variable with the no error status
    Status status = new Status(IStatus.OK, "not_used", 0, "", null);
    // If the event is triggered by the destination or departure fields
    // set the corresponding status variable to the right value
    WizardDialog2 container = (WizardDialog2)getContainer();
    if (container != null){
      Object object = container.getSelectedPage();
      
      if (object instanceof KvAoeNeuSeite1)
      {
        if (event.widget == backButton){
          
          KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
          KvAoeNeuModell model = wizard.model;
          if (model._autoCloser != null){
            model._config.close();
            model._config = null;
          }
        }      
      }      
    }
    
    // // Show the most serious error
    setPageComplete(isPageComplete());
    getWizard().getContainer().updateButtons();
  }

  /*
   * Returns the next page. Saves the values from this page in the model associated with the wizard. Initializes the
   * widgets on the next page.
   */

  // public IWizardPage getNextPage()
  // {
  // saveDataToModel();
  // if (kvButton.getSelection())
  // {
  // HolidayMainPage2 page = ((HolidayWizard)getWizard()).planePage;
  // // page.onEnterPage();
  // return page;
  // }
  // // Returns the next page depending on the selected button
  // if (aoeButton.getSelection())
  // {
  // CarPage page = ((HolidayWizard)getWizard()).carPage;
  // return page;
  // }
  // return false;
  // }

  /**
   * @see IWizardPage#canFlipToNextPage()
   */
  public boolean canFlipToNextPage()
  {
    saveDataToModel();

    // if (getErrorMessage() != null)
    // return false;
    //
    // if (isTextNonEmpty(textName) && isTextNonEmpty(textOrtKonfig) && isTextNonEmpty(textOrtOrdner))
    // {
    // return true;
    //
    // }

    return false;
  }

  /*
   * Saves the uses choices from this page to the model. Called on exit of the page
   */
  private void saveDataToModel()
  {    
    KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
    KvAoeNeuModell model = wizard.model;

    model._info = textInfo.getText();
    model._beschreibung = textInfo2.getText();
    model._infoDef = textInfoAOE.getText();
    model._beschreibungDef = textInfo2AOE.getText();

//    if (model._config == null){
//      model._config = _config;
//    }
//    if (model._autoCloser == null){
//      model._autoCloser = _tAutoCloser;
//    }

  }

  /*
   * Sets the completed field on the wizard class when all the information is entered and the wizard can be completed
   */
  public boolean isPageComplete()
  {
    KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();

    wizard.seite3Complete = true;

    saveDataToModel();
    return true;
  }

  /**
   * Applies the status to the status line of a dialog page.
   */
  private void applyToStatusLine(IStatus status)
  {
    String message = status.getMessage();
    if (message.length() == 0)
      message = null;
    switch (status.getSeverity())
    {
      case IStatus.OK:
        setErrorMessage(null);
        setMessage(message);
        break;
      case IStatus.WARNING:
        setErrorMessage(null);
        setMessage(message, WizardPage.WARNING);
        break;
      case IStatus.INFO:
        setErrorMessage(null);
        setMessage(message, WizardPage.INFORMATION);
        break;
      default:
        setErrorMessage(message);
        setMessage(null);
        break;
    }
  }

  // private IStatus findMostSevere()
  // {
  // if (timeStatus.matches(IStatus.ERROR))
  // return timeStatus;
  // if (destinationStatus.matches(IStatus.ERROR))
  // return destinationStatus;
  // if (timeStatus.getSeverity() > destinationStatus.getSeverity())
  // return timeStatus;
  // else
  // return destinationStatus;
  // }

  private static boolean isTextNonEmpty(Text t)
  {
    if (t != null)
    {
      String s = t.getText();
      if ((s != null) && (s.trim().length() > 0))
        return true;
    }
    return false;
  }

  private void createLine(Composite parent, int ncol)
  {
    Label line = new Label(parent, SWT.SEPARATOR | SWT.HORIZONTAL | SWT.BOLD);
    GridData gridData = new GridData(GridData.FILL_HORIZONTAL);
    gridData.horizontalSpan = ncol;
    line.setLayoutData(gridData);
  }

  void onEnterPage()
  {
    KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
    KvAoeNeuModell model = wizard.model;
    
    if (model.useKV && model._config == null){
      String ziel = model.getZielVerzeichnis();
      String pfad = ziel + "/config/verwaltungsdaten.xml";
      
      MyConfigurationManagementFile managementFile = new MyManagementFile(new File(pfad));
      
      List<MyConfigurationAreaManagementInfo> camis = managementFile.getAllMyConfigurationAreaManagementInfos();
      String q = model.getQuellVerzeichnis();
      String z = model.getZielVerzeichnis();
      
//      System.out.println("Quelle: " + q);
//      System.out.println("Ziel: " + z);
      
      for (MyConfigurationAreaManagementInfo cami : camis)
      {
        String pid = cami.getPid();
        File dir = cami.getDirectory();
        
        String s1 = dir.getPath();
        
        if (s1.contains(z))
        {
          String s2 = s1.replace(z, q);
          
          URI uriBase = new File(s1.replace("\\", "/")).toURI();
          URI uriRelative = new File(s2.replace("\\", "/")).toURI();
          
          URI uri = uriBase.relativize(uriRelative);
          try
          {
            cami.setDirectory(new File(uri).getCanonicalFile());
            cami.delAllVersionInfo();
          }
          catch (IOException e)
          {
            // TODO Auto-generated catch block
            e.printStackTrace();
          }
          
        }
      }
      
      try
      {
        managementFile.save();
        managementFile.close();
         
        ladeDatenmodellAssistent(pfad);

      }
      catch (IOException e)
      {
        // TODO Auto-generated catch block
        e.printStackTrace();
      }     
    }


    setPageComplete(isPageComplete());

    if (!model.useAOE)
    {
      aoeButton.setSelection(false);
      kvButton.setSelection(true);
      textInfo2AOE.setEnabled(false);
      textInfoAOE.setEnabled(false);
    }
    else
    {
      aoeButton.setSelection(true);
      kvButton.setSelection(false);
      textInfo2AOE.setEnabled(true);
      textInfoAOE.setEnabled(true);
    }
  }

  private void ladeDatenmodellAssistent(final String pfad)
  {
    IRunnableWithProgress op2 = new IRunnableWithProgress() {

      private MultiStatus _status;

      @Override
      public void run(IProgressMonitor monitor) throws InvocationTargetException, InterruptedException
      {

        KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
        KvAoeNeuModell model = wizard.model;
        
        if (model.useKV)
          monitor.beginTask("Lade Datenmodell", 1);
        else monitor.beginTask("Lade Datenmodell / Bestimme Mengen", 1);

        try
        {
          _status = new MultiStatus(Activator.PLUGIN_ID, Status.OK, "Starte Laden des Datenmodells", null);
          MeldungenSpeicher.getInstanz().setStatus(_status);

          File file = new File(pfad);

          
          Display.getDefault().asyncExec(new Runnable() {
            
            @Override
            public void run()
            {
              cancelButton.setEnabled(false);                        
            }
          });
          
          model._config = erzeugeKonfigDatenModellAusDatei(file);
          
          monitor.worked(1);
          
          if (model._config != null){                                    
            _status.add(new Status(Status.OK, Activator.PLUGIN_ID, "Laden Datenmodell erfolgreich abgeschlossen. "));
          }
        }
        catch (Exception e)
        {
          _status.add(new Status(Status.ERROR, Activator.PLUGIN_ID,
              "Aktion Laden Datenmodell fehlgeschlagen, die evt. geladene Konfiguration wurde geschlossen. "));
        }
        finally
        {
          Display.getDefault().asyncExec(new Runnable() {
            
            @Override
            public void run()
            {
              cancelButton.setEnabled(true);                        
            }
          });
          
          MeldungenSpeicher.getInstanz().hinzufuegenMultimeldung(_status, System.currentTimeMillis(), true);
          monitor.done();
        }
      }
    };
    try
    {
      WizardDialog2 container = (WizardDialog2)getContainer();
      container.run(true, true, op2);
    }
    catch (InvocationTargetException e)
    {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
    catch (InterruptedException e)
    {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
  }
  
  /**
   * Erzeugt das Offline-Datenmodell der Konfiguration aus der XML-Verwaltungsdatei
   * 
   * @param configurationFile
   *          die Verwaltungsdatei
   * @return das Offline-Datenmodell
   */
  public ConfigDataModel erzeugeKonfigDatenModellAusDatei(File configurationFile)
  {
    try
    {
      final ConfigDataModel configuration = new ConfigDataModel(configurationFile);

      Runnable autoCloser = new Runnable() {
        public void run()
        {
          configuration.close();
        }
      };

      KvAoeNeuAssistent wizard = (KvAoeNeuAssistent)getWizard();
      KvAoeNeuModell model = wizard.model;
      
      if (model._autoCloser != null){
        Runtime.getRuntime().removeShutdownHook(model._autoCloser);        
      }
      
      model._autoCloser = new Thread(autoCloser);
      Runtime.getRuntime().addShutdownHook(model._autoCloser);

      return configuration;
    }
    catch (Exception e)
    {
      _status = new MultiStatus(Activator.PLUGIN_ID, Status.OK, "Fehler beim Laden des Datenmodells", e);
      MeldungenSpeicher.getInstanz().setStatus(_status);
    }
    return null;

  }
  

}
