/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkabasis.datenbereich.editor;

import org.eclipse.swt.widgets.Composite;

import de.bsvrz.dav.daf.main.Data;

/**
 * Klasse fr die virtuellen Elemente, die frs Scrollen bei der virtuellen Darstellung bentigt werden 
 * 
 * @author Krause
 *
 */
public class VirtuellesElement
{

  Composite _parent;

  Data _data;

  int _x;
  
  int _y;

  int _index;

  boolean _arrayElement; 
  
  int _virtuelleHoehe;

  protected VirtuellesElement(Composite parent, final Data data, int x, int y, int index, boolean isArrayElement, int virtuelleHoehe)
  {
    _parent = parent;
    _data = data;
    _x = x;
    _y = y;
    _index = index;
    _arrayElement = isArrayElement;
    _virtuelleHoehe = virtuelleHoehe;
  }

  protected Composite getParent()
  {
    return _parent;
  }

  protected Data getData()
  {
    return _data;
  }

  public void setData(Data data)
  {
    _data = data;
  }
  
  protected int getX()
  {
    return _x;
  }

  protected int getY()
  {
    return _y;
  }
 
  public int getIndex()
  {
    return _index;
  }
  
  public void setIndex( int index )
  {
    _index = index;
  }
  
  protected boolean isArrayElement()
  {
    return _arrayElement;
  }
    
  protected int getVirtuelleHoehe()
  {
    return _virtuelleHoehe;
  }
}
