/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkabasis.datenbereich.editor.widgetChangedListener;

import java.util.EventObject;

import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Widget;

import de.bsvrz.dav.daf.main.Data;

public class WidgetChangedEvent extends EventObject
{
	private static final long serialVersionUID = 1365256169927819792L;
	
	/**
	 * Widgetobjekt
	 */
	private Widget _widget;
  
	 /**
   * Dataobjekt zum Widget
   */
  private Data _data;
  
  /**
   * Gruppenobjekt zum Widget
   */
  private Group _gruppe;
  
	/**
	 * Konstruktor
	 * 
	 * @param quelle Quelle des Events.
	 * @param widget auslsendes Widget.
	 * @param data   Dataobjekt zum Widget.
	 * @param grp    Gruppenobjekt zum Widget.
	 */
	public WidgetChangedEvent(Object quelle, Widget widget, Data data, Group grp)
	{
		super(quelle);
		_widget = widget;
		_data = data;
		_gruppe = grp;
		
	}
	
	/**
	 * Liefert das empfangene Widgetobjekt zurck.
	 * @return Widgetobjekt.
	 */
	public Widget getWidgetObjekt()
	{
		return this._widget;
	}
  
	 /**
   * Liefert das empfangene Dataobjekt zum Widget zurck.
   * @return Dataobjekt.
   */
  public Data getDataobjekt()
  {
    return this._data;
  }
  
  /**
   * Liefert das empfangene Gruppenobjekt zum Widget zurck.
   * @return Gruppenobjekt.
   */
  public Group getGroupObjekt()
  {
    return this._gruppe;
  }

}
